<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 10</a>

    <script>
    
        let T = 8;

        const problemaReinas = (tablero) => { 
            
            for (var i = 0; i < T; i++) {
                for (var j = 0; j < T; j++) {
                    document.write(tablero[i][j] + " ");
                }
                document.write("<br>");
            }
        }

        const sinMorir = (tablero, fila, colum) => {
            
            for (var i = 0; i < colum; i++) {
                if(tablero[fila][i] === 1) {
                    return false;
                }
            }

            for (var i = fila, j = colum; i >= 0 && j >= 0; i--, j--) {
                if(tablero[i][j]) {
                    return false;
                }
            }

            for (var i = fila, j = colum; j >= 0 && i < T; i++, j--) {
                if(tablero[i][j]) {
                    return false;
                }
            }

            return true
        } 
        
        const resolverPRUtil = (tablero, colum) => {
            if (colum >= T) {
                return true;
            }

            for (var i = 0; i < T; i++) { 

                if (sinMorir(tablero, i, colum) === true) {
                    tablero[i][colum] = 1;
                    if (resolverPRUtil(tablero, colum + 1) === true) {
                        return true
                    }
                    tablero[i][colum] = 0;
                }
            }
            return false;
        }

        const resolverPR = () => {
            let tablero = [
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
                [0, 0, 0, 0, 0, 0, 0, 0],
            ];

            if (resolverPRUtil(tablero, 0) === false) {
                console.log("No hay solucion");
                return false;
            }
            document.write("<br>");
            document.write("Solución:");
            document.write("<br>");
            problemaReinas(tablero);
            return true;
        }

        resolverPR();
        
        
</script>
    
</body>
</html>